package de.humance.eco.profile.model.impl;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.ProxyUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;
import com.liferay.portlet.expando.util.ExpandoBridgeFactoryUtil;

import de.humance.eco.profile.model.Trailer;
import de.humance.eco.profile.model.TrailerModel;

import java.io.Serializable;

import java.sql.Types;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * The base model implementation for the Trailer service. Represents a row in the &quot;Profile_Trailer&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This implementation and its corresponding interface {@link de.humance.eco.profile.model.TrailerModel} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link TrailerImpl}.
 * </p>
 *
 * @author Humance
 * @see TrailerImpl
 * @see de.humance.eco.profile.model.Trailer
 * @see de.humance.eco.profile.model.TrailerModel
 * @generated
 */
public class TrailerModelImpl extends BaseModelImpl<Trailer>
    implements TrailerModel {
    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify or reference this class directly. All methods that expect a trailer model instance should use the {@link de.humance.eco.profile.model.Trailer} interface instead.
     */
    public static final String TABLE_NAME = "Profile_Trailer";
    public static final Object[][] TABLE_COLUMNS = {
            { "trailerId", Types.BIGINT },
            { "creatorId", Types.BIGINT },
            { "creatorName", Types.VARCHAR },
            { "createDate", Types.TIMESTAMP },
            { "modifierId", Types.BIGINT },
            { "modifierName", Types.VARCHAR },
            { "modifiedDate", Types.TIMESTAMP },
            { "driverId", Types.BIGINT },
            { "typeId", Types.BIGINT },
            { "manufacturerId", Types.BIGINT },
            { "organizationId", Types.BIGINT },
            { "modelName", Types.VARCHAR },
            { "dimensionHeight", Types.BIGINT },
            { "dimensionWidth", Types.BIGINT },
            { "dimensionDepth", Types.BIGINT },
            { "licensePlate", Types.VARCHAR }
        };
    public static final String TABLE_SQL_CREATE = "create table Profile_Trailer (trailerId LONG not null primary key,creatorId LONG,creatorName VARCHAR(75) null,createDate DATE null,modifierId LONG,modifierName VARCHAR(75) null,modifiedDate DATE null,driverId LONG,typeId LONG,manufacturerId LONG,organizationId LONG,modelName VARCHAR(75) null,dimensionHeight LONG,dimensionWidth LONG,dimensionDepth LONG,licensePlate VARCHAR(75) null)";
    public static final String TABLE_SQL_DROP = "drop table Profile_Trailer";
    public static final String ORDER_BY_JPQL = " ORDER BY trailer.manufacturerId ASC, trailer.modelName ASC";
    public static final String ORDER_BY_SQL = " ORDER BY Profile_Trailer.manufacturerId ASC, Profile_Trailer.modelName ASC";
    public static final String DATA_SOURCE = "liferayDataSource";
    public static final String SESSION_FACTORY = "liferaySessionFactory";
    public static final String TX_MANAGER = "liferayTransactionManager";
    public static final boolean ENTITY_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.entity.cache.enabled.de.humance.eco.profile.model.Trailer"),
            true);
    public static final boolean FINDER_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.finder.cache.enabled.de.humance.eco.profile.model.Trailer"),
            true);
    public static final boolean COLUMN_BITMASK_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.column.bitmask.enabled.de.humance.eco.profile.model.Trailer"),
            true);
    public static long DRIVERID_COLUMN_BITMASK = 1L;
    public static long LICENSEPLATE_COLUMN_BITMASK = 2L;
    public static long MANUFACTURERID_COLUMN_BITMASK = 4L;
    public static long MODELNAME_COLUMN_BITMASK = 8L;
    public static long ORGANIZATIONID_COLUMN_BITMASK = 16L;
    public static long TYPEID_COLUMN_BITMASK = 32L;
    public static final long LOCK_EXPIRATION_TIME = GetterUtil.getLong(com.liferay.util.service.ServiceProps.get(
                "lock.expiration.time.de.humance.eco.profile.model.Trailer"));
    private static ClassLoader _classLoader = Trailer.class.getClassLoader();
    private static Class<?>[] _escapedModelInterfaces = new Class[] {
            Trailer.class
        };
    private long _trailerId;
    private long _creatorId;
    private String _creatorName;
    private Date _createDate;
    private long _modifierId;
    private String _modifierName;
    private Date _modifiedDate;
    private long _driverId;
    private long _originalDriverId;
    private boolean _setOriginalDriverId;
    private long _typeId;
    private long _originalTypeId;
    private boolean _setOriginalTypeId;
    private long _manufacturerId;
    private long _originalManufacturerId;
    private boolean _setOriginalManufacturerId;
    private long _organizationId;
    private long _originalOrganizationId;
    private boolean _setOriginalOrganizationId;
    private String _modelName;
    private String _originalModelName;
    private long _dimensionHeight;
    private long _dimensionWidth;
    private long _dimensionDepth;
    private String _licensePlate;
    private String _originalLicensePlate;
    private long _columnBitmask;
    private Trailer _escapedModel;

    public TrailerModelImpl() {
    }

    @Override
    public long getPrimaryKey() {
        return _trailerId;
    }

    @Override
    public void setPrimaryKey(long primaryKey) {
        setTrailerId(primaryKey);
    }

    @Override
    public Serializable getPrimaryKeyObj() {
        return _trailerId;
    }

    @Override
    public void setPrimaryKeyObj(Serializable primaryKeyObj) {
        setPrimaryKey(((Long) primaryKeyObj).longValue());
    }

    @Override
    public Class<?> getModelClass() {
        return Trailer.class;
    }

    @Override
    public String getModelClassName() {
        return Trailer.class.getName();
    }

    @Override
    public Map<String, Object> getModelAttributes() {
        Map<String, Object> attributes = new HashMap<String, Object>();

        attributes.put("trailerId", getTrailerId());
        attributes.put("creatorId", getCreatorId());
        attributes.put("creatorName", getCreatorName());
        attributes.put("createDate", getCreateDate());
        attributes.put("modifierId", getModifierId());
        attributes.put("modifierName", getModifierName());
        attributes.put("modifiedDate", getModifiedDate());
        attributes.put("driverId", getDriverId());
        attributes.put("typeId", getTypeId());
        attributes.put("manufacturerId", getManufacturerId());
        attributes.put("organizationId", getOrganizationId());
        attributes.put("modelName", getModelName());
        attributes.put("dimensionHeight", getDimensionHeight());
        attributes.put("dimensionWidth", getDimensionWidth());
        attributes.put("dimensionDepth", getDimensionDepth());
        attributes.put("licensePlate", getLicensePlate());

        return attributes;
    }

    @Override
    public void setModelAttributes(Map<String, Object> attributes) {
        Long trailerId = (Long) attributes.get("trailerId");

        if (trailerId != null) {
            setTrailerId(trailerId);
        }

        Long creatorId = (Long) attributes.get("creatorId");

        if (creatorId != null) {
            setCreatorId(creatorId);
        }

        String creatorName = (String) attributes.get("creatorName");

        if (creatorName != null) {
            setCreatorName(creatorName);
        }

        Date createDate = (Date) attributes.get("createDate");

        if (createDate != null) {
            setCreateDate(createDate);
        }

        Long modifierId = (Long) attributes.get("modifierId");

        if (modifierId != null) {
            setModifierId(modifierId);
        }

        String modifierName = (String) attributes.get("modifierName");

        if (modifierName != null) {
            setModifierName(modifierName);
        }

        Date modifiedDate = (Date) attributes.get("modifiedDate");

        if (modifiedDate != null) {
            setModifiedDate(modifiedDate);
        }

        Long driverId = (Long) attributes.get("driverId");

        if (driverId != null) {
            setDriverId(driverId);
        }

        Long typeId = (Long) attributes.get("typeId");

        if (typeId != null) {
            setTypeId(typeId);
        }

        Long manufacturerId = (Long) attributes.get("manufacturerId");

        if (manufacturerId != null) {
            setManufacturerId(manufacturerId);
        }

        Long organizationId = (Long) attributes.get("organizationId");

        if (organizationId != null) {
            setOrganizationId(organizationId);
        }

        String modelName = (String) attributes.get("modelName");

        if (modelName != null) {
            setModelName(modelName);
        }

        Long dimensionHeight = (Long) attributes.get("dimensionHeight");

        if (dimensionHeight != null) {
            setDimensionHeight(dimensionHeight);
        }

        Long dimensionWidth = (Long) attributes.get("dimensionWidth");

        if (dimensionWidth != null) {
            setDimensionWidth(dimensionWidth);
        }

        Long dimensionDepth = (Long) attributes.get("dimensionDepth");

        if (dimensionDepth != null) {
            setDimensionDepth(dimensionDepth);
        }

        String licensePlate = (String) attributes.get("licensePlate");

        if (licensePlate != null) {
            setLicensePlate(licensePlate);
        }
    }

    @Override
    public long getTrailerId() {
        return _trailerId;
    }

    @Override
    public void setTrailerId(long trailerId) {
        _trailerId = trailerId;
    }

    @Override
    public long getCreatorId() {
        return _creatorId;
    }

    @Override
    public void setCreatorId(long creatorId) {
        _creatorId = creatorId;
    }

    @Override
    public String getCreatorName() {
        if (_creatorName == null) {
            return StringPool.BLANK;
        } else {
            return _creatorName;
        }
    }

    @Override
    public void setCreatorName(String creatorName) {
        _creatorName = creatorName;
    }

    @Override
    public Date getCreateDate() {
        return _createDate;
    }

    @Override
    public void setCreateDate(Date createDate) {
        _createDate = createDate;
    }

    @Override
    public long getModifierId() {
        return _modifierId;
    }

    @Override
    public void setModifierId(long modifierId) {
        _modifierId = modifierId;
    }

    @Override
    public String getModifierName() {
        if (_modifierName == null) {
            return StringPool.BLANK;
        } else {
            return _modifierName;
        }
    }

    @Override
    public void setModifierName(String modifierName) {
        _modifierName = modifierName;
    }

    @Override
    public Date getModifiedDate() {
        return _modifiedDate;
    }

    @Override
    public void setModifiedDate(Date modifiedDate) {
        _modifiedDate = modifiedDate;
    }

    @Override
    public long getDriverId() {
        return _driverId;
    }

    @Override
    public void setDriverId(long driverId) {
        _columnBitmask |= DRIVERID_COLUMN_BITMASK;

        if (!_setOriginalDriverId) {
            _setOriginalDriverId = true;

            _originalDriverId = _driverId;
        }

        _driverId = driverId;
    }

    public long getOriginalDriverId() {
        return _originalDriverId;
    }

    @Override
    public long getTypeId() {
        return _typeId;
    }

    @Override
    public void setTypeId(long typeId) {
        _columnBitmask |= TYPEID_COLUMN_BITMASK;

        if (!_setOriginalTypeId) {
            _setOriginalTypeId = true;

            _originalTypeId = _typeId;
        }

        _typeId = typeId;
    }

    public long getOriginalTypeId() {
        return _originalTypeId;
    }

    @Override
    public long getManufacturerId() {
        return _manufacturerId;
    }

    @Override
    public void setManufacturerId(long manufacturerId) {
        _columnBitmask = -1L;

        if (!_setOriginalManufacturerId) {
            _setOriginalManufacturerId = true;

            _originalManufacturerId = _manufacturerId;
        }

        _manufacturerId = manufacturerId;
    }

    public long getOriginalManufacturerId() {
        return _originalManufacturerId;
    }

    @Override
    public long getOrganizationId() {
        return _organizationId;
    }

    @Override
    public void setOrganizationId(long organizationId) {
        _columnBitmask |= ORGANIZATIONID_COLUMN_BITMASK;

        if (!_setOriginalOrganizationId) {
            _setOriginalOrganizationId = true;

            _originalOrganizationId = _organizationId;
        }

        _organizationId = organizationId;
    }

    public long getOriginalOrganizationId() {
        return _originalOrganizationId;
    }

    @Override
    public String getModelName() {
        if (_modelName == null) {
            return StringPool.BLANK;
        } else {
            return _modelName;
        }
    }

    @Override
    public void setModelName(String modelName) {
        _columnBitmask = -1L;

        if (_originalModelName == null) {
            _originalModelName = _modelName;
        }

        _modelName = modelName;
    }

    public String getOriginalModelName() {
        return GetterUtil.getString(_originalModelName);
    }

    @Override
    public long getDimensionHeight() {
        return _dimensionHeight;
    }

    @Override
    public void setDimensionHeight(long dimensionHeight) {
        _dimensionHeight = dimensionHeight;
    }

    @Override
    public long getDimensionWidth() {
        return _dimensionWidth;
    }

    @Override
    public void setDimensionWidth(long dimensionWidth) {
        _dimensionWidth = dimensionWidth;
    }

    @Override
    public long getDimensionDepth() {
        return _dimensionDepth;
    }

    @Override
    public void setDimensionDepth(long dimensionDepth) {
        _dimensionDepth = dimensionDepth;
    }

    @Override
    public String getLicensePlate() {
        if (_licensePlate == null) {
            return StringPool.BLANK;
        } else {
            return _licensePlate;
        }
    }

    @Override
    public void setLicensePlate(String licensePlate) {
        _columnBitmask |= LICENSEPLATE_COLUMN_BITMASK;

        if (_originalLicensePlate == null) {
            _originalLicensePlate = _licensePlate;
        }

        _licensePlate = licensePlate;
    }

    public String getOriginalLicensePlate() {
        return GetterUtil.getString(_originalLicensePlate);
    }

    public long getColumnBitmask() {
        return _columnBitmask;
    }

    @Override
    public ExpandoBridge getExpandoBridge() {
        return ExpandoBridgeFactoryUtil.getExpandoBridge(0,
            Trailer.class.getName(), getPrimaryKey());
    }

    @Override
    public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
        ExpandoBridge expandoBridge = getExpandoBridge();

        expandoBridge.setAttributes(serviceContext);
    }

    @Override
    public Trailer toEscapedModel() {
        if (_escapedModel == null) {
            _escapedModel = (Trailer) ProxyUtil.newProxyInstance(_classLoader,
                    _escapedModelInterfaces, new AutoEscapeBeanHandler(this));
        }

        return _escapedModel;
    }

    @Override
    public Object clone() {
        TrailerImpl trailerImpl = new TrailerImpl();

        trailerImpl.setTrailerId(getTrailerId());
        trailerImpl.setCreatorId(getCreatorId());
        trailerImpl.setCreatorName(getCreatorName());
        trailerImpl.setCreateDate(getCreateDate());
        trailerImpl.setModifierId(getModifierId());
        trailerImpl.setModifierName(getModifierName());
        trailerImpl.setModifiedDate(getModifiedDate());
        trailerImpl.setDriverId(getDriverId());
        trailerImpl.setTypeId(getTypeId());
        trailerImpl.setManufacturerId(getManufacturerId());
        trailerImpl.setOrganizationId(getOrganizationId());
        trailerImpl.setModelName(getModelName());
        trailerImpl.setDimensionHeight(getDimensionHeight());
        trailerImpl.setDimensionWidth(getDimensionWidth());
        trailerImpl.setDimensionDepth(getDimensionDepth());
        trailerImpl.setLicensePlate(getLicensePlate());

        trailerImpl.resetOriginalValues();

        return trailerImpl;
    }

    @Override
    public int compareTo(Trailer trailer) {
        int value = 0;

        if (getManufacturerId() < trailer.getManufacturerId()) {
            value = -1;
        } else if (getManufacturerId() > trailer.getManufacturerId()) {
            value = 1;
        } else {
            value = 0;
        }

        if (value != 0) {
            return value;
        }

        value = getModelName().compareToIgnoreCase(trailer.getModelName());

        if (value != 0) {
            return value;
        }

        return 0;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }

        if (!(obj instanceof Trailer)) {
            return false;
        }

        Trailer trailer = (Trailer) obj;

        long primaryKey = trailer.getPrimaryKey();

        if (getPrimaryKey() == primaryKey) {
            return true;
        } else {
            return false;
        }
    }

    @Override
    public int hashCode() {
        return (int) getPrimaryKey();
    }

    @Override
    public void resetOriginalValues() {
        TrailerModelImpl trailerModelImpl = this;

        trailerModelImpl._originalDriverId = trailerModelImpl._driverId;

        trailerModelImpl._setOriginalDriverId = false;

        trailerModelImpl._originalTypeId = trailerModelImpl._typeId;

        trailerModelImpl._setOriginalTypeId = false;

        trailerModelImpl._originalManufacturerId = trailerModelImpl._manufacturerId;

        trailerModelImpl._setOriginalManufacturerId = false;

        trailerModelImpl._originalOrganizationId = trailerModelImpl._organizationId;

        trailerModelImpl._setOriginalOrganizationId = false;

        trailerModelImpl._originalModelName = trailerModelImpl._modelName;

        trailerModelImpl._originalLicensePlate = trailerModelImpl._licensePlate;

        trailerModelImpl._columnBitmask = 0;
    }

    @Override
    public CacheModel<Trailer> toCacheModel() {
        TrailerCacheModel trailerCacheModel = new TrailerCacheModel();

        trailerCacheModel.trailerId = getTrailerId();

        trailerCacheModel.creatorId = getCreatorId();

        trailerCacheModel.creatorName = getCreatorName();

        String creatorName = trailerCacheModel.creatorName;

        if ((creatorName != null) && (creatorName.length() == 0)) {
            trailerCacheModel.creatorName = null;
        }

        Date createDate = getCreateDate();

        if (createDate != null) {
            trailerCacheModel.createDate = createDate.getTime();
        } else {
            trailerCacheModel.createDate = Long.MIN_VALUE;
        }

        trailerCacheModel.modifierId = getModifierId();

        trailerCacheModel.modifierName = getModifierName();

        String modifierName = trailerCacheModel.modifierName;

        if ((modifierName != null) && (modifierName.length() == 0)) {
            trailerCacheModel.modifierName = null;
        }

        Date modifiedDate = getModifiedDate();

        if (modifiedDate != null) {
            trailerCacheModel.modifiedDate = modifiedDate.getTime();
        } else {
            trailerCacheModel.modifiedDate = Long.MIN_VALUE;
        }

        trailerCacheModel.driverId = getDriverId();

        trailerCacheModel.typeId = getTypeId();

        trailerCacheModel.manufacturerId = getManufacturerId();

        trailerCacheModel.organizationId = getOrganizationId();

        trailerCacheModel.modelName = getModelName();

        String modelName = trailerCacheModel.modelName;

        if ((modelName != null) && (modelName.length() == 0)) {
            trailerCacheModel.modelName = null;
        }

        trailerCacheModel.dimensionHeight = getDimensionHeight();

        trailerCacheModel.dimensionWidth = getDimensionWidth();

        trailerCacheModel.dimensionDepth = getDimensionDepth();

        trailerCacheModel.licensePlate = getLicensePlate();

        String licensePlate = trailerCacheModel.licensePlate;

        if ((licensePlate != null) && (licensePlate.length() == 0)) {
            trailerCacheModel.licensePlate = null;
        }

        return trailerCacheModel;
    }

    @Override
    public String toString() {
        StringBundler sb = new StringBundler(33);

        sb.append("{trailerId=");
        sb.append(getTrailerId());
        sb.append(", creatorId=");
        sb.append(getCreatorId());
        sb.append(", creatorName=");
        sb.append(getCreatorName());
        sb.append(", createDate=");
        sb.append(getCreateDate());
        sb.append(", modifierId=");
        sb.append(getModifierId());
        sb.append(", modifierName=");
        sb.append(getModifierName());
        sb.append(", modifiedDate=");
        sb.append(getModifiedDate());
        sb.append(", driverId=");
        sb.append(getDriverId());
        sb.append(", typeId=");
        sb.append(getTypeId());
        sb.append(", manufacturerId=");
        sb.append(getManufacturerId());
        sb.append(", organizationId=");
        sb.append(getOrganizationId());
        sb.append(", modelName=");
        sb.append(getModelName());
        sb.append(", dimensionHeight=");
        sb.append(getDimensionHeight());
        sb.append(", dimensionWidth=");
        sb.append(getDimensionWidth());
        sb.append(", dimensionDepth=");
        sb.append(getDimensionDepth());
        sb.append(", licensePlate=");
        sb.append(getLicensePlate());
        sb.append("}");

        return sb.toString();
    }

    @Override
    public String toXmlString() {
        StringBundler sb = new StringBundler(52);

        sb.append("<model><model-name>");
        sb.append("de.humance.eco.profile.model.Trailer");
        sb.append("</model-name>");

        sb.append(
            "<column><column-name>trailerId</column-name><column-value><![CDATA[");
        sb.append(getTrailerId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>creatorId</column-name><column-value><![CDATA[");
        sb.append(getCreatorId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>creatorName</column-name><column-value><![CDATA[");
        sb.append(getCreatorName());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>createDate</column-name><column-value><![CDATA[");
        sb.append(getCreateDate());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>modifierId</column-name><column-value><![CDATA[");
        sb.append(getModifierId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>modifierName</column-name><column-value><![CDATA[");
        sb.append(getModifierName());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>modifiedDate</column-name><column-value><![CDATA[");
        sb.append(getModifiedDate());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>driverId</column-name><column-value><![CDATA[");
        sb.append(getDriverId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>typeId</column-name><column-value><![CDATA[");
        sb.append(getTypeId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>manufacturerId</column-name><column-value><![CDATA[");
        sb.append(getManufacturerId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>organizationId</column-name><column-value><![CDATA[");
        sb.append(getOrganizationId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>modelName</column-name><column-value><![CDATA[");
        sb.append(getModelName());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>dimensionHeight</column-name><column-value><![CDATA[");
        sb.append(getDimensionHeight());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>dimensionWidth</column-name><column-value><![CDATA[");
        sb.append(getDimensionWidth());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>dimensionDepth</column-name><column-value><![CDATA[");
        sb.append(getDimensionDepth());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>licensePlate</column-name><column-value><![CDATA[");
        sb.append(getLicensePlate());
        sb.append("]]></column-value></column>");

        sb.append("</model>");

        return sb.toString();
    }
}
